"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.TextSemanticMark = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), enums_1 = require("./enums");

class TextSemanticMark extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.text, id);
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.text;
    }
    parseScaleOfEncodeX(option) {
        const res = super.parseScaleOfEncodeX(option);
        return res.type = "point", res;
    }
    parseScaleByEncode(channel, option) {
        return this.parseScaleOfCommonEncode(channel, option);
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = markEncoder;
        return res.text && (res.text = {
            field: res.text.field
        }), markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color || markEncoder.group ? res.fill = null !== (_a = markEncoder.color) && void 0 !== _a ? _a : markEncoder.group : res.fill = null !== (_c = null === (_b = this.spec.style) || void 0 === _b ? void 0 : _b.fill) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0], 
        res;
    }
}

exports.TextSemanticMark = TextSemanticMark, TextSemanticMark.type = enums_1.PlotMakType.text;
//# sourceMappingURL=text.js.map